# coding: utf-8

"""
    Orbipay-Checkout APIs

    API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and Charge Management related APIs. 

    OpenAPI spec version: 1.0.0
    Contact: checkout.orbipay@alacriti.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class InlineResponse2001(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'charge_id': 'str',
        'confirmation_number': 'str',
        'charge_status': 'str',
        'charge_amount': 'str',
        'charge_amount_currency': 'str',
        'charge_date': 'str',
        'funding_account_info': 'PublicservicepaymentsvalidatechargePARTNERIDFundingAccountInfo',
        'customer_info': 'PublicservicepaymentsvalidatechargePARTNERIDCustomerInfo',
        'customer_account_info': 'InlineResponse2001CustomerAccountInfo',
        'custom_fields': 'object'
    }

    attribute_map = {
        'charge_id': 'charge_id',
        'confirmation_number': 'confirmation_number',
        'charge_status': 'charge_status',
        'charge_amount': 'charge_amount',
        'charge_amount_currency': 'charge_amount_currency',
        'charge_date': 'charge_date',
        'funding_account_info': 'funding_account_info',
        'customer_info': 'customer_info',
        'customer_account_info': 'customer_account_info',
        'custom_fields': 'custom_fields'
    }

    def __init__(self, charge_id=None, confirmation_number=None, charge_status=None, charge_amount=None, charge_amount_currency=None, charge_date=None, funding_account_info=None, customer_info=None, customer_account_info=None, custom_fields=None):
        """
        InlineResponse2001 - a model defined in Swagger
        """

        self._charge_id = None
        self._confirmation_number = None
        self._charge_status = None
        self._charge_amount = None
        self._charge_amount_currency = None
        self._charge_date = None
        self._funding_account_info = None
        self._customer_info = None
        self._customer_account_info = None
        self._custom_fields = None

        if charge_id is not None:
          self.charge_id = charge_id
        if confirmation_number is not None:
          self.confirmation_number = confirmation_number
        if charge_status is not None:
          self.charge_status = charge_status
        if charge_amount is not None:
          self.charge_amount = charge_amount
        if charge_amount_currency is not None:
          self.charge_amount_currency = charge_amount_currency
        if charge_date is not None:
          self.charge_date = charge_date
        if funding_account_info is not None:
          self.funding_account_info = funding_account_info
        if customer_info is not None:
          self.customer_info = customer_info
        if customer_account_info is not None:
          self.customer_account_info = customer_account_info
        if custom_fields is not None:
          self.custom_fields = custom_fields

    @property
    def charge_id(self):
        """
        Gets the charge_id of this InlineResponse2001.
        Id is a unique identifier assigned to a payment in OrbiPay-Checkout system.

        :return: The charge_id of this InlineResponse2001.
        :rtype: str
        """
        return self._charge_id

    @charge_id.setter
    def charge_id(self, charge_id):
        """
        Sets the charge_id of this InlineResponse2001.
        Id is a unique identifier assigned to a payment in OrbiPay-Checkout system.

        :param charge_id: The charge_id of this InlineResponse2001.
        :type: str
        """
        if charge_id is not None and len(charge_id) > 50:
            raise ValueError("Invalid value for `charge_id`, length must be less than or equal to `50`")
        if charge_id is not None and len(charge_id) < 0:
            raise ValueError("Invalid value for `charge_id`, length must be greater than or equal to `0`")
        if charge_id is not None and not re.search('^[A-Za-z0-9-_]{0,50}$', charge_id):
            raise ValueError("Invalid value for `charge_id`, must be a follow pattern or equal to `/^[A-Za-z0-9-_]{0,50}$/`")

        self._charge_id = charge_id

    @property
    def confirmation_number(self):
        """
        Gets the confirmation_number of this InlineResponse2001.
        A unique reference assigned to the charge by Orbipay-Checkout system for any future communications

        :return: The confirmation_number of this InlineResponse2001.
        :rtype: str
        """
        return self._confirmation_number

    @confirmation_number.setter
    def confirmation_number(self, confirmation_number):
        """
        Sets the confirmation_number of this InlineResponse2001.
        A unique reference assigned to the charge by Orbipay-Checkout system for any future communications

        :param confirmation_number: The confirmation_number of this InlineResponse2001.
        :type: str
        """
        if confirmation_number is not None and len(confirmation_number) > 25:
            raise ValueError("Invalid value for `confirmation_number`, length must be less than or equal to `25`")
        if confirmation_number is not None and len(confirmation_number) < 0:
            raise ValueError("Invalid value for `confirmation_number`, length must be greater than or equal to `0`")
        if confirmation_number is not None and not re.search('[a-z0-9]{0,25}', confirmation_number):
            raise ValueError("Invalid value for `confirmation_number`, must be a follow pattern or equal to `/[a-z0-9]{0,25}/`")

        self._confirmation_number = confirmation_number

    @property
    def charge_status(self):
        """
        Gets the charge_status of this InlineResponse2001.
        Status of the charge

        :return: The charge_status of this InlineResponse2001.
        :rtype: str
        """
        return self._charge_status

    @charge_status.setter
    def charge_status(self, charge_status):
        """
        Sets the charge_status of this InlineResponse2001.
        Status of the charge

        :param charge_status: The charge_status of this InlineResponse2001.
        :type: str
        """
        allowed_values = ["scheduled", "cancelled", "processing", "processed", "returned", "declined", "disputed", "refunded", "failed", "submitted"]
        #if charge_status not in allowed_values:
        #    raise ValueError(
        #        "Invalid value for `charge_status` ({0}), must be one of {1}"
        #        .format(charge_status, allowed_values)
        #    )

        self._charge_status = charge_status

    @property
    def charge_amount(self):
        """
        Gets the charge_amount of this InlineResponse2001.
        Amount fields are of format N [9, 2] with . as decimal separator         (for e.g. 100.20).

        :return: The charge_amount of this InlineResponse2001.
        :rtype: str
        """
        return self._charge_amount

    @charge_amount.setter
    def charge_amount(self, charge_amount):
        """
        Sets the charge_amount of this InlineResponse2001.
        Amount fields are of format N [9, 2] with . as decimal separator         (for e.g. 100.20).

        :param charge_amount: The charge_amount of this InlineResponse2001.
        :type: str
        """

        self._charge_amount = charge_amount

    @property
    def charge_amount_currency(self):
        """
        Gets the charge_amount_currency of this InlineResponse2001.
        3 character ISO currency code should be provided in currencyCode3d field defaulted to USD if its not populated.

        :return: The charge_amount_currency of this InlineResponse2001.
        :rtype: str
        """
        return self._charge_amount_currency

    @charge_amount_currency.setter
    def charge_amount_currency(self, charge_amount_currency):
        """
        Sets the charge_amount_currency of this InlineResponse2001.
        3 character ISO currency code should be provided in currencyCode3d field defaulted to USD if its not populated.

        :param charge_amount_currency: The charge_amount_currency of this InlineResponse2001.
        :type: str
        """
        if charge_amount_currency is not None and len(charge_amount_currency) > 3:
            raise ValueError("Invalid value for `charge_amount_currency`, length must be less than or equal to `3`")
        if charge_amount_currency is not None and len(charge_amount_currency) < 3:
            raise ValueError("Invalid value for `charge_amount_currency`, length must be greater than or equal to `3`")
        if charge_amount_currency is not None and not re.search('^[A-Za-z]{3}$', charge_amount_currency):
            raise ValueError("Invalid value for `charge_amount_currency`, must be a follow pattern or equal to `/^[A-Za-z]{3}$/`")

        self._charge_amount_currency = charge_amount_currency

    @property
    def charge_date(self):
        """
        Gets the charge_date of this InlineResponse2001.
        payment date should be in mm/dd/yyyy.

        :return: The charge_date of this InlineResponse2001.
        :rtype: str
        """
        return self._charge_date

    @charge_date.setter
    def charge_date(self, charge_date):
        """
        Sets the charge_date of this InlineResponse2001.
        payment date should be in mm/dd/yyyy.

        :param charge_date: The charge_date of this InlineResponse2001.
        :type: str
        """

        self._charge_date = charge_date

    @property
    def funding_account_info(self):
        """
        Gets the funding_account_info of this InlineResponse2001.

        :return: The funding_account_info of this InlineResponse2001.
        :rtype: PublicservicepaymentsvalidatechargePARTNERIDFundingAccountInfo
        """
        return self._funding_account_info

    @funding_account_info.setter
    def funding_account_info(self, funding_account_info):
        """
        Sets the funding_account_info of this InlineResponse2001.

        :param funding_account_info: The funding_account_info of this InlineResponse2001.
        :type: PublicservicepaymentsvalidatechargePARTNERIDFundingAccountInfo
        """

        self._funding_account_info = funding_account_info

    @property
    def customer_info(self):
        """
        Gets the customer_info of this InlineResponse2001.

        :return: The customer_info of this InlineResponse2001.
        :rtype: PublicservicepaymentsvalidatechargePARTNERIDCustomerInfo
        """
        return self._customer_info

    @customer_info.setter
    def customer_info(self, customer_info):
        """
        Sets the customer_info of this InlineResponse2001.

        :param customer_info: The customer_info of this InlineResponse2001.
        :type: PublicservicepaymentsvalidatechargePARTNERIDCustomerInfo
        """

        self._customer_info = customer_info

    @property
    def customer_account_info(self):
        """
        Gets the customer_account_info of this InlineResponse2001.

        :return: The customer_account_info of this InlineResponse2001.
        :rtype: InlineResponse2001CustomerAccountInfo
        """
        return self._customer_account_info

    @customer_account_info.setter
    def customer_account_info(self, customer_account_info):
        """
        Sets the customer_account_info of this InlineResponse2001.

        :param customer_account_info: The customer_account_info of this InlineResponse2001.
        :type: InlineResponse2001CustomerAccountInfo
        """

        self._customer_account_info = customer_account_info

    @property
    def custom_fields(self):
        """
        Gets the custom_fields of this Charge.

        :return: The custom_fields of this Charge.
        :rtype: FieldStringMap
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """
        Sets the custom_fields of this Charge.

        :param custom_fields: The custom_fields of this Charge.
        :type: FieldStringMap
        """

        self._custom_fields = custom_fields

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, InlineResponse2001):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
