from __future__ import absolute_import

import json
import os

from ..exceptions import ApiException
from ..checkout import Checkout
from .logger_util import LoggerUtil


# python 2 and python 3 compatibility library


# from six.moves.urllib.parse import quote

class PropertiesFileReader(object):
    logger = LoggerUtil.setup_logger(__name__)

    CHECKOUT_API_SERVICE_URL = "CHECKOUT_API_SERVICE_URL"
    CHECKOUT_TLS_CERTIFICATE_LOCATION = "CHECKOUT_TLS_CERTIFICATE_LOCATION"
    CHECKOUT_PUBLIC_KEY_LOCATION = "CHECKOUT_PUBLIC_KEY_LOCATION"
    CLIENT_PRIVATE_KEY_LOCATION = "CLIENT_PRIVATE_KEY_LOCATION"
    CLIENT_PRIVATE_KEY_PASSWORD = "CLIENT_PRIVATE_KEY_PASSWORD"
    properties = None
    path = ""
    stream = ""

    @classmethod
    def get_properties_from_file(cls):
        print("In get_properties_from_file:")
        PropertiesFileReader.stream = Checkout.getPropertiesStream()
        if(PropertiesFileReader.stream != "" or len(PropertiesFileReader.stream) != 0):
            print("setting props using stream")
            try:
                PropertiesFileReader.properties = json.load(PropertiesFileReader.stream)
                print("Props using stream: ",PropertiesFileReader.properties)
            except BaseException as e:
                raise ApiException(
                    status=0,
                    reason="setting props using stream failed"
                )

        else:
            PropertiesFileReader.path = Checkout.getPropertiesFilePath()

            if(PropertiesFileReader.path == "" or len(PropertiesFileReader.path) == 0):
                print("setting from environment variable ORBIPAY_CHECKOUT_CONFIG")
                try:
                    PropertiesFileReader.path = os.environ["ORBIPAY_CHECKOUT_CONFIG"]
                except BaseException as e:
                    #logger.error("exception occured: {}".format(e))
                    raise ApiException(
                        status=0,
                        reason="path for propertiesFile not provided"
                    )

            try:
                with open(PropertiesFileReader.path, 'r') as properties_file:
                    PropertiesFileReader.properties = json.load(properties_file)
            except BaseException as e:
                #logger.error("exception occured: {}".format(e))
                raise ApiException(
                    status=0,
                    reason="failed to load properties {}".format(properties_file)
                )

    @classmethod
    def get_property(cls, property_name):
        PropertiesFileReader.logger.info('property_name: {}'.format(property_name))
        if (PropertiesFileReader.properties is None):
            PropertiesFileReader.get_properties_from_file()
        return PropertiesFileReader.properties[property_name]
